package de.luh.dcsec.usecpassboard;

import java.util.List;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.ContextMenu;
import android.view.ContextMenu.ContextMenuInfo;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ListAdapter;
import android.widget.TextView;

public class DialogActivity extends Activity {

	static final String MESSAGE = "de.luh.dcsec.usecpassboard.DialogActivity.CREDENTIAL";
	private String currentActivity;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);

		Intent intent = getIntent();
		currentActivity = intent.getStringExtra(USecPassBoard.EXTRA_ACTIVITY);

		setContentView(R.layout.activity_dialog);

		if (currentActivity != null && currentActivity.length() > 0) {

			CredentialsDataSource db = new CredentialsDataSource(
					getApplicationContext());

			db.open("");

			final List<Credential> all = db.getCredentials(currentActivity);

			db.close();

			if (all.size() > 0) {

				CharSequence[] items = new CharSequence[all.size()];
				Log.i("pick", "picked " + all.size());
				for (int i = 0; i < all.size(); i++) {
					items[i] = all.get(i).getUsername();
				}

				ListAdapter adapter = new ArrayAdapter<Credential>(
						getApplicationContext(), R.layout.credentials_list, all) {
					ViewHolder holder;

					class ViewHolder {
						TextView username;
						TextView context;
					}

					@Override
					public View getView(int position, View convertView,
							ViewGroup parent) {
						final LayoutInflater inflater = (LayoutInflater) getApplicationContext()
								.getSystemService(
										Context.LAYOUT_INFLATER_SERVICE);

						if (convertView == null) {
							convertView = inflater.inflate(
									R.layout.credentials_list, null);

							holder = new ViewHolder();
							holder.username = (TextView) convertView
									.findViewById(R.id.username);
							holder.context = (TextView) convertView
									.findViewById(R.id.context);
							convertView.setTag(holder);
						} else {
							// view already defined, retrieve view holder
							holder = (ViewHolder) convertView.getTag();
						}

						holder.username
								.setText(all.get(position).getUsername());
						holder.context.setText(all.get(position).getActivity());

						return convertView;
					}
				};

				AlertDialog.Builder builder = new AlertDialog.Builder(this, android.R.style.Theme_Holo_Dialog/*,
						android.R.style.Theme_DeviceDefault_Dialog*/);
				builder.setTitle("Select a username")
						/*
						 * .setItems(items, new
						 * DialogInterface.OnClickListener() {
						 * 
						 * @Override public void onClick(DialogInterface dialog,
						 * int which) { Log.i("pick", "picked " + which);
						 * 
						 * Credential p = all.get(which);
						 * 
						 * Intent intent = new Intent(MESSAGE);
						 * intent.putExtra(USecPassBoard.EXTRA_ACTIVITY,
						 * p.getActivity());
						 * intent.putExtra(USecPassBoard.EXTRA_USERNAME,
						 * p.getUsername());
						 * intent.putExtra(USecPassBoard.EXTRA_PASSWORD,
						 * p.getPassword());
						 * 
						 * sendBroadcast(intent);
						 * 
						 * DialogActivity.this.finish(); } })
						 */
						.setAdapter(adapter,
								new DialogInterface.OnClickListener() {

									@Override
									public void onClick(DialogInterface dialog,
											int which) {
										Credential p = all.get(which);

										Intent intent = new Intent(MESSAGE);
										intent.putExtra(
												USecPassBoard.EXTRA_ACTIVITY,
												p.getActivity());
										intent.putExtra(
												USecPassBoard.EXTRA_USERNAME,
												p.getUsername());
										intent.putExtra(
												USecPassBoard.EXTRA_PASSWORD,
												p.getPassword());

										sendBroadcast(intent);

										DialogActivity.this.finish();
									}
								})
						.setCancelable(true)
						.setNeutralButton("Abort",
								new DialogInterface.OnClickListener() {
									public void onClick(DialogInterface dialog,
											int id) {
										DialogActivity.this.finish();
									}
								});

				AlertDialog a = builder.create();
				View list = a.getListView();
				a.registerForContextMenu(list);

				a.show();
				DialogActivity.this.registerForContextMenu(list);
				// list.setOnCreateContextMenuListener(this);
			} else {
				AlertDialog.Builder builder = new AlertDialog.Builder(this,
						android.R.style.Theme_DeviceDefault_Dialog_MinWidth);
				builder.setMessage(
						"No credentials found for" + " (" + currentActivity
								+ ")").setNeutralButton("OK",
						new DialogInterface.OnClickListener() {

							@Override
							public void onClick(DialogInterface dialog,
									int which) {
								DialogActivity.this.finish();
							}
						});

				AlertDialog a = builder.create();
				a.show();

				// registerForContextMenu(findViewById(R.layout.credentials_list));
			}
		} else {
			this.finish();
		}
	}

	@Override
	public void onCreateContextMenu(ContextMenu menu, View v,
			ContextMenuInfo menuInfo) {
		Log.d("DialogList", "context menu created");
		getMenuInflater().inflate(R.menu.activity_credential_detail, menu);
	}

	@Override
	public boolean onContextItemSelected(MenuItem item) {
		Log.d("Dialog", "selected");
		switch (item.getItemId()) {
		case R.id.menu_credential_delete:
			Log.d("Dialog", "delete credential");
			break;
		case R.id.menu_credential_add_context:
			Log.d("Dialog", "add credential context");
		}

		return super.onContextItemSelected(item);
	}
	
	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		Log.d("Dialog", "selected3");
		switch (item.getItemId()) {
		case R.id.menu_credential_delete:
			Log.d("Dialog", "delete credential");
			break;
		case R.id.menu_credential_add_context:
			Log.d("Dialog", "add credential context");
		}
		return super.onOptionsItemSelected(item);
	}

	@Override
	public boolean onMenuItemSelected(int featureId, MenuItem item) {

		Log.d("Dialog", "selected");
		switch (item.getItemId()) {
		case R.id.menu_credential_delete:
			Log.d("Dialog", "delete credential");
			break;
		case R.id.menu_credential_add_context:
			Log.d("Dialog", "add credential context");
		}

		return true;
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		getMenuInflater().inflate(R.menu.activity_dialog, menu);

		return true;
	}
	
	class CreadentialDialog extends AlertDialog implements DialogInterface.OnClickListener {

		public CreadentialDialog(Context context) {
			super(context);
			// TODO Auto-generated constructor stub
			
			setTitle("Select a username");
			setCancelable(true);
			setButton(BUTTON_NEUTRAL, "Abort", this);
			registerForContextMenu(getListView());
			//getListView().setAdapter(adapter);
		}

		@Override
		public void onClick(DialogInterface dialog, int which) {
			
		}
		
		
		
	}
}
