package de.luh.dcsec.usecpassboard;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.view.Menu;
import android.widget.Toast;
import de.luh.dcsec.usecpassboard.R;

public class StoreActivity extends Activity {
	private Credential credential;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        
        Intent intent = getIntent();
        String activity = intent.getStringExtra(USecPassBoard.EXTRA_ACTIVITY);
        String username = intent.getStringExtra(USecPassBoard.EXTRA_USERNAME);
        String password = intent.getStringExtra(USecPassBoard.EXTRA_PASSWORD);
        
        credential = new Credential();
        credential.setActivity(activity);
        credential.setUsername(username);
        credential.setPassword(password);
        
        setContentView(R.layout.activity_store);
        
        AlertDialog.Builder builder = new AlertDialog.Builder(this, android.R.style.Theme_DeviceDefault_Dialog);
        builder.setMessage(getText(R.string.message_activity_store) + " " + activity + "?").setPositiveButton(android.R.string.yes, new DialogInterface.OnClickListener() {
			
			@Override
			public void onClick(DialogInterface dialog, int which) {
				CredentialsDataSource cd = CredentialsDataSource.getInstance(getApplicationContext());
				//CredentialsDataSource cd = new CredentialsDataSource(getApplicationContext());
				
				//cd.open();
				
				cd.createCredential(credential.getActivity(), credential.getUsername(), credential.getPassword());
				
				//cd.close();
				
				/*AlertDialog.Builder builder1 = new AlertDialog.Builder(StoreActivity.this, android.R.style.Theme_DeviceDefault_Dialog_MinWidth);
				builder1.setMessage("Credentials stored successfully").setNeutralButton("OK", new DialogInterface.OnClickListener() {
					
					@Override
					public void onClick(DialogInterface dialog, int which) {
							StoreActivity.this.finish();
					}
				});
				
				AlertDialog ad1 = builder1.create();
				ad1.show();*/
				
				Toast.makeText(StoreActivity.this, R.string.message_activity_store_success, Toast.LENGTH_LONG).show();
				StoreActivity.this.finish();
			}
		}).setNegativeButton(android.R.string.no, new DialogInterface.OnClickListener() {
			
			@Override
			public void onClick(DialogInterface dialog, int which) {
				StoreActivity.this.finish();
			}
		});
        
        AlertDialog ad = builder.create();
        ad.show();
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.activity_store, menu);
        return true;
    }
}
